#!/usr/bin/perl
### scorp_log.pl
################################

require "./scorp-lib.pl";
use Encode qw(from_to);
use Encode::Guess qw/euc-jp shiftjis utf8 7bit-jis/;

use utf8;

&ReadParse;

my $v_search_word = $in{'v_search_word'}; 
my @v_search_dir  = split(/[\0\,]/,$in{'v_search_dir'}); 
my $v_search_dirs;
foreach (@v_search_dir){
	$v_search_dirs=$v_search_dirs.$_.",";
}
my $v_sort_key = $in{'v_sort_key'}; 
my $v_sort_order = $in{'v_sort_order'}; 
my $v_result_page = $in{'v_result_page'};

##############################################

&print_scorp_head($scorp_title{"log"},$menu_tab{"log"},$v_search_word,$v_search_dirs,$v_sort_key,$v_sort_order,$v_result_page);
&display_log;
&print_scorp_foot;

sub display_log{
	print <<EOF;
<div class="scorp-body">
<p class="scorp-body">
"Log" Page is not done yet.
<br>
Manual is <a href="../manual.html" target="_blank">here</a>.
</p>
</div>
EOF
}
