#!/usr/bin/perl
### scorp_result.cgi
################################

require "./scorp-lib.pl";
use Encode qw(from_to);
use Encode::Guess qw/euc-jp shiftjis utf8 7bit-jis/;

use utf8;

&ReadParse;

my $v_search_word = $in{'v_search_word'}; 
if($v_search_word=~ /^[\s\t\n]$/){ $v_search_word="\\w+"; }
if($v_search_word eq ""){ $v_search_word="\\w+"; }
my $decoded_search_word = $v_search_word;
utf8::decode($decoded_search_word);
#utf8::is_utf8("$decoded_search_word") ? &CgiError("$decoded_search_word<em>&larr;UTF8-Flag有り</em>") : &CgiError("$decoded_search_word<em>&larr;UTF8-Flag無し</em>");
#あああ
#utf8で保存します．
my @v_search_dir  = split(/[\0\,]/,$in{'v_search_dir'}); 
my $v_search_dirs;
foreach (@v_search_dir){
	$v_search_dirs=$v_search_dirs.$_.",";
}
my $v_sort_key = $in{'v_sort_key'}; 
my $v_sort_order = $in{'v_sort_order'}; 
my $v_result_page = $in{'v_result_page'};

if($v_search_dirs=~ /^[\0\,\s\t\n]*$/){ &show_dialog_jump($scorp_url{'search'},"<em class=\"scorp-body\">WARNING:</em> CHOOSE DIRECTORY(S) TO SEARCH."); exit(-1);};

my ($v_corpus_top_dir,$v_max_result_rows,$v_max_result_columns,$v_max_result_chars,$v_max_search_word_history)=&read_scorp_option;

##############################################

&print_scorp_head($scorp_title{"result"},$menu_tab{"result"},$v_search_word,$v_search_dirs,$v_sort_key,$v_sort_order,$v_result_page);
#print "word:$v_search_word;<br>dir:$v_search_dirs;<br>key:$v_sort_key;<br>order:$v_sort_order;<br>page:$v_result_page;<br>";

my $search_file=&read_corpus($v_search_dirs);
my @search_files;
foreach (@{$search_file}){
	push(@search_files,$_);
}
my @array_result_info_allfiles;
my @array_results_info_eachfile;
my @array_results_info_eachhit;

my %results_info_word_count;
my @array_results_info_word_count;

if($v_sort_key eq "default"){
	$v_sort_key="hitword";
}
if($v_sort_order eq ""){
	$v_sort_order="ascending";
}
&write_search_word_history($v_search_word,$v_max_search_word_history);
&search_scorp;
&display_scorp_result;
&print_scorp_foot;

##############################################
my $hit_word_id;

sub search_scorp{
	$array_result_info_allfiles[$result_info_allfiles{"search_word"}]=$v_search_word;
	$array_result_info_allfiles[$result_info_allfiles{"search_file_num"}]=0;
	$array_result_info_allfiles[$result_info_allfiles{"search_line_num"}]=0;
	$array_result_info_allfiles[$result_info_allfiles{"hit_line_num"}]=0;
	$array_result_info_allfiles[$result_info_allfiles{"hit_word_num"}]=0;
	my $file_num=0;
	my $count_word_id=0;
	foreach (@search_files){
		$array_result_info_allfiles[$result_info_allfiles{"search_file_num"}]++;

		my @results_info_eachfile;
		$results_info_eachfile[$result_info_eachfile{"search_word"}]=$v_search_word;
		$results_info_eachfile[$result_info_eachfile{"file_name"}]=$_;
		$results_info_eachfile[$result_info_eachfile{"guessed_code"}]="";
		$results_info_eachfile[$result_info_eachfile{"content"}]="";
		$results_info_eachfile[$result_info_eachfile{"search_line_num"}]=0;
		$results_info_eachfile[$result_info_eachfile{"hit_line_num"}]=0;
		$results_info_eachfile[$result_info_eachfile{"hit_line_id"}]=0;
		$results_info_eachfile[$result_info_eachfile{"hit_word_num"}]=0;
		$results_info_eachfile[$result_info_eachfile{"hit_word_id"}]="";
		open(IN,$_) || &CgiDie("$_:$!");
		while(<IN>){
			if($.==1){
				$results_info_eachfile[$result_info_eachfile{"content"}]=$_;
			}else{
				#$results_info_eachfile[$result_info_eachfile{"content"}]=$results_info_eachfile[$result_info_eachfile{"content"}]."ZZZ".$_;
				$results_info_eachfile[$result_info_eachfile{"content"}]=$results_info_eachfile[$result_info_eachfile{"content"}].$LINE_SEPARATOR.$_;
			}
		}
		close(IN);
		$results_info_eachfile[$result_info_eachfile{"guessed_code"}]=Encode::Guess::guess_encoding($results_info_eachfile[$result_info_eachfile{"content"}]);
		unless(ref $results_info_eachfile[$result_info_eachfile{"guessed_code"}]){
			$results_info_eachfile[$result_info_eachfile{"content"}]=$results_info_eachfile[$result_info_eachfile{"guessed_code"}];
		}else{
			from_to($results_info_eachfile[$result_info_eachfile{"content"}], 'Guess', 'utf8');
			utf8::decode($results_info_eachfile[$result_info_eachfile{"content"}]);
		}

		my @Contents=split(/$LINE_SEPARATOR/,$results_info_eachfile[$result_info_eachfile{"content"}]);
		my $line_id=0;
		foreach (@Contents){
			my $line=$_;
			$line_id++;
			$array_result_info_allfiles[$result_info_allfiles{"search_line_num"}]++;
			$results_info_eachfile[$result_info_eachfile{"search_line_num"}]++;
			$line=&symbol_code($line);
			chomp $line;
			if(($line ne "") && ($line=~ /$decoded_search_word/)){
				$array_result_info_allfiles[$result_info_allfiles{"hit_line_num"}]++;
				$results_info_eachfile[$result_info_eachfile{"hit_line_num"}]++;
				$results_info_eachfile[$result_info_eachfile{"hit_line_id"}]=$line_id;
				while($line=~ m/($decoded_search_word)/g){
					$array_result_info_allfiles[$result_info_allfiles{"hit_word_num"}]++;

					my $match0=$`;my $match1=$&;my $match2=$';
					my $match0_cut_num=int(abs($v_max_result_chars-length($match1))/2);
					my $match2_cut_num=$match0_cut_num;;
					if(length($match1)%2==1){
						$match0_cut_num+=1;
					}
					my $match0_length=length($match0);
					my $match2_length=length($match2);
					my $match0_cut=substr($match0,-$match0_cut_num);
					my $match2_cut=substr($match2,0,$match2_cut_num);
					my $match1_bold=${HIGH_LIGHT_HEAD}.${match1}.${HIGH_LIGHT_TAIL};

					$results_info_eachfile[$result_info_eachfile{"hit_word_num"}]++;
					$results_info_eachfile[$result_info_eachfile{"hit_word_id"}]=$hit_word_id;

					my @results_info_eachhit;
					$results_info_eachhit[$result_info_eachhit{"file_name"}]=$results_info_eachfile[$result_info_eachfile{"file_name"}];
					$results_info_eachhit[$result_info_eachhit{"hit_line_id"}]=$line_id;
					$results_info_eachhit[$result_info_eachhit{"hit_line"}]=$match0.$match1.$match2;
					$results_info_eachhit[$result_info_eachhit{"hit_word"}]=$match1;
					$results_info_eachhit[$result_info_eachhit{"hit_paragraph"}]=$match0_cut.$match1.$match2_cut;
					$results_info_eachhit[$result_info_eachhit{"hit_paragraph_highlighted"}]=$match0_cut.$match1_bold.$match2_cut;

					utf8::encode($results_info_eachhit[$result_info_eachhit{"hit_line"}]);
					utf8::encode($results_info_eachhit[$result_info_eachhit{"hit_word"}]);
					utf8::encode($results_info_eachhit[$result_info_eachhit{"hit_paragraph"}]);
					utf8::encode($results_info_eachhit[$result_info_eachhit{"hit_paragraph_hightlighted"}]);
					push(@array_results_info_eachhit,[@results_info_eachhit]);

					$hit_word_id++;
					$count_word_id++;
				}
			}
		}
		utf8::encode($results_info_eachfile[$result_info_eachfile{"content"}]);
		push(@array_results_info_eachfile,[@results_info_eachfile]);
		$file_num++;
	}

### Sorting 
	if($v_sort_key eq "hitsentence"){
		if($v_sort_order eq "ascending"){
			@array_results_info_eachhit = sort {
				@$a[$result_info_eachhit{'hit_paragraph'}] cmp @$b[$result_info_eachhit{'hit_paragraph'}]
			} @array_results_info_eachhit;
		}else{#if($v_sort_order eq "descending"){
			@array_results_info_eachhit = sort {
				@$b[$result_info_eachhit{'hit_paragraph'}] cmp @$a[$result_info_eachhit{'hit_paragraph'}]
			} @array_results_info_eachhit;
		}
	}else{#if(($v_sort_key eq "hitword"){
		if($v_sort_order eq "ascending"){
			@array_results_info_eachhit = sort {
				@$a[$result_info_eachhit{'hit_word'}] cmp @$b[$result_info_eachhit{'hit_word'}]
			} @array_results_info_eachhit;
		}else{#if($v_sort_order eq "descending"){
			@array_results_info_eachhit = sort {
				@$b[$result_info_eachhit{'hit_word'}] cmp @$a[$result_info_eachhit{'hit_word'}]
			} @array_results_info_eachhit;
		}
	}
### Sorting 
}

sub display_scorp_result{
	my $result_first=$v_result_page*$v_max_result_rows+1;
	my $result_last=0;
	if($array_result_info_allfiles[$result_info_allfiles{"hit_word_num"}]-$result_first>=$v_max_result_rows){
		$result_last=$result_first+$v_max_result_rows-1;
	}else{
		$result_last=$result_first+($array_result_info_allfiles[$result_info_allfiles{"hit_word_num"}]-$result_first)%$v_max_result_rows;
	}
	print <<EOF;
<div class="scorp-body">
<center>
<table class="scorp-body" border="0">
<caption>
<h3 class="scorp-body">
Descriptive Info 
</h3>
</caption>
    <tr>
      <th class="scorp-body-descriptive">Search Key</th>
      <td class="scorp-body"align="left">$array_result_info_allfiles[$result_info_allfiles{"search_word"}]</td>
	</tr>
    <tr>
      <th class="scorp-body-descriptive">Number of Files Searched</th>
      <td class="scorp-body"align="left">$array_result_info_allfiles[$result_info_allfiles{"search_file_num"}]</td>
	</tr>
	<tr>
      <th class="scorp-body-descriptive">Name of Files Searched</th>
      <td class="scorp-body" align="left">
EOF
	foreach	(@array_results_info_eachfile){
		print "$_->[$result_info_eachfile{'file_name'}]<br>";
	}
print <<EOF;
	  </td>
    <tr>
      <th class="scorp-body-descriptive">Number of Lines Searched</th>
      <td class="scorp-body"align="left">$array_result_info_allfiles[$result_info_allfiles{"search_line_num"}]</td>
	</tr>
    <tr>
      <th class="scorp-body-descriptive">Number of Lines including the Hit Word</th>
      <td class="scorp-body"align="left">$array_result_info_allfiles[$result_info_allfiles{"hit_line_num"}]</td>
	</tr>
    <tr>
      <th class="scorp-body-descriptive">Number of the Hit Word</th>
      <td class="scorp-body"align="left">$array_result_info_allfiles[$result_info_allfiles{"hit_word_num"}]</td>
	</tr>
</table>
<h1 class="scorp-body">
SCORP RESULT
</h1>
<table class="scorp-body" width="100%" border="0">
<caption>
EOF
	my $num_search_files=@search_files;	
	if($num_search_files==0){
		my $dialog="No File in the Directory(s),@v_search_dir";
		#&show_dialog_jump($scorp_url{'search'},"$dialog");
		print <<EOF;
<em class="scorp-body">
$dialog
</em>
EOF
	}elsif($hit_word_id==0){
		#&show_dialog_jump($scorp_url{'search'},"No Hit...");
		print <<EOF;
<em class="scorp-body">
No Hit
</em>
EOF
	}else{
		my $current_page=$v_result_page+1;
		print <<EOF;
<h3 class="scorp-body">
Displaying Page $current_page: Result(s) $result_first - $result_last out of $array_result_info_allfiles[$result_info_allfiles{"hit_word_num"}] 
</h3>
</caption>
<tbody>
<tr>
<th class="scorp-body">ID</th>
<th class="scorp-body">
<center>
<table>
<tr>
<th class="scorp-body">
<form action="$scorp_url{'result'}" method="post"> 
<input type="hidden" name="v_search_word" value="$v_search_word">
<input type="hidden" name="v_search_dir" value="$v_search_dirs">
<input type="hidden" name="v_sort_key" value="hitword">
<input type="hidden" name="v_sort_order" value="ascending">
<input type="hidden" name="v_result_page" value="0">
<input type="image" src="$scorp_url{'images'}sort_ascending.gif" alt="Asc" align="right">
</form>
</th>
<th class="scorp-body">
Hit Word
</th>
<th class="scorp-body">
<form action="$scorp_url{'result'}" method="post"> 
<input type="hidden" name="v_search_word" value="$v_search_word">
<input type="hidden" name="v_search_dir" value="$v_search_dirs">
<input type="hidden" name="v_sort_key" value="hitword">
<input type="hidden" name="v_sort_order" value="descending">
<input type="hidden" name="v_result_page" value="0">
<input type="image" src="$scorp_url{'images'}sort_descending.gif" alt="Des" align="left">
</form>
</th>
</tr>
</table>
</center>
</th>
<th class="scorp-body">
<center>
<table>
<tr>
<th class="scorp-body">
<form action="$scorp_url{'result'}" method="post"> 
<input type="hidden" name="v_search_word" value="$v_search_word">
<input type="hidden" name="v_search_dir" value="$v_search_dirs">
<input type="hidden" name="v_sort_key" value="hitsentence">
<input type="hidden" name="v_sort_order" value="ascending">
<input type="hidden" name="v_result_page" value="0">
<input type="image" src="$scorp_url{'images'}sort_ascending.gif" alt="Asc" align="right">
</form>
</th>
<th class="scorp-body">
Hit Sentence
</th>
<th class="scorp-body">
<form action="$scorp_url{'result'}" method="post"> 
<input type="hidden" name="v_search_word" value="$v_search_word">
<input type="hidden" name="v_search_dir" value="$v_search_dirs">
<input type="hidden" name="v_sort_key" value="hitsentence">
<input type="hidden" name="v_sort_order" value="descending">
<input type="hidden" name="v_result_page" value="0">
<input type="image" src="$scorp_url{'images'}sort_descending.gif" alt="Des" align="left">
</form>
</th>
</tr>
</table>
</center>
</th>
<th class="scorp-body">Detail</th>
</tr>
EOF

		my $id=0;
		for($id=$result_first;$id<=$result_last;$id++){
			if($array_results_info_eachhit[$id-1][$result_info_eachhit{"hit_paragraph_highlighted"}] ne ""){
				my $hit_paragraph_highlighted=$array_results_info_eachhit[$id-1][$result_info_eachhit{"hit_paragraph_highlighted"}];
				my $hit_word=$array_results_info_eachhit[$id-1][$result_info_eachhit{"hit_word"}];
				utf8::decode($hit_paragraph_highlighted);
				utf8::decode($hit_word);
				my $replaced=$hit_paragraph_highlighted;

				$hit_paragraph_highlighted=~ m/($HIGH_LIGHT_HEAD)/;
				my $match0=$`;
				my $match1=$hit_word;
				$hit_paragraph_highlighted=~ m/($HIGH_LIGHT_TAIL)/;
				my $match2=$';
				my $match0_cut_num=int(abs($v_max_result_chars-length($match1))/2);
				if(length($match1)%2==1){
					$match0_cut_num+=1;
				}
				my $match0_length=length($match0);
				my $match0_cut=substr($match0,-$match0_cut_num);
				my $match0_space=$match0_cut_num-$match0_length;
				my $i;
				for($i=0;$i<$match0_space;$i++){
					$match0_cut="&nbsp;".$match0_cut;
				}
				$replaced=$match0_cut."<b><font color=\"$scorp_color{'Pink'}\">".$match1."<\/font><\/b>".$match2;

				$hit_paragraph_highlighted=$replaced;

				if($id%2){
					print "<tr bgcolor=\"".$scorp_color{"White"}."\">";
				}else{
					print "<tr bgcolor=\"".$scorp_color{"Gray"}."\">";
				}
				$display_id=$id+1;

				utf8::encode($hit_paragraph_highlighted);
				utf8::encode($hit_word);
				print <<EOF;
<td>$id</td>
<td><b><font face="monospace">$hit_word</font></b></td>
<td align="left"><span style="font-family:monospace"><TT>$hit_paragraph_highlighted</TT></span></td>
EOF

#my $show_file=$scorp_url{"show_file"}."?v_file_name=".$array_results_info_eachhit[$id-1][$result_info_eachhit{"file_name"}]."&amp;v_line_id=".$array_results_info_eachhit[$id-1][$result_info_eachhit{"hit_line_id"}]."&amp;v_hit_word=".$array_results_info_eachhit[$id-1][$result_info_eachhit{'hit_word'}];
#<input type="hidden" name="v_content" value="$results_info_eachfile[$result_info_eachfile{"content"}]">
#<input type="submit" value="Detail">
				print <<EOF;
<td>
<form action="$scorp_url{"show_file"}" method="post"> 
<input type="submit" value="$array_results_info_eachhit[$id-1][$result_info_eachhit{"hit_line_id"}]">
<input type="hidden" name="v_file_name" value="$array_results_info_eachhit[$id-1][$result_info_eachhit{"file_name"}]">
<input type="hidden" name="v_hit_line_id" value="$array_results_info_eachhit[$id-1][$result_info_eachhit{"hit_line_id"}]">
<input type="hidden" name="v_hit_word" value="$hit_word">
</form>

</td>
</tr>
EOF
			}
		}
		my $total_num_pages=int($array_result_info_allfiles[$result_info_allfiles{"hit_word_num"}]/$v_max_result_rows);
		if($array_result_info_allfiles[$result_info_allfiles{"hit_word_num"}]%$v_max_result_rows){
			$total_num_pages++;
		}
		my @pages_url;
		my $page_num=0;
		for($page_num=0;$page_num<$total_num_pages;$page_num++){
			my $page_url=$scorp_url{"result"}."?v_search_word=$v_search_word&amp;v_search_dir=$v_search_dirs&amp;v_sort_key=$v_sort_key&amp;v_sort_order=$v_sort_order&amp;v_result_page=$page_num";
			push(@pages_url,$page_url);
		}
		print <<EOF;
</tbody>
</table>
<p class="scorp-body">
<h4 class="scorp-body">
EOF
		$page_num=1;
		foreach (@pages_url){
			if($page_num==$v_result_page+1){
				print "$page_num\n";
			}else{
				my $page_url="<a class=\"scorp-body\" href=\"$_\">$page_num</a>";
				print "$page_url\n";
			}
			$page_num++;
		}
		print <<EOF;
</h4>
</p>
</center>
</div>
EOF
	}
}

