#!/usr/bin/perl
#scorp_search.cgi
#

require "./scorp-lib.pl";
use utf8;

&ReadParse;

my $v_search_word = $in{'v_search_word'}; 
my @v_search_dir  = split(/[\0\,]/,$in{'v_search_dir'}); 
my $v_search_dirs;
foreach (@v_search_dir){
	$v_search_dirs=$v_search_dirs.$_.",";
}
my $v_sort_key = $in{'v_sort_key'}; 
my $v_sort_order = $in{'v_sort_order'}; 
my $v_result_page = $in{'v_result_page'};

if($v_search_word=~ /^[\s\t\n]$/){ $v_search_word=""; }
if(!(-f $scorp_url{"search_word_history"})||($in{'clear'}eq "On")){
	&clear_search_word_history;
}
my ($v_corpus_top_dir,$v_max_result_rows,$v_max_result_columns,$v_max_result_chars,$v_max_search_word_history)=&read_scorp_option;

##############################################

&print_scorp_head($scorp_title{"search"},$menu_tab{"search"},$v_search_word,$v_search_dirs,$v_sort_key,$v_sort_order,$v_result_page);
#print "word:$v_search_word;<br>dir:$v_search_dirs;<br>key:$v_sort_key;<br>order:$v_sort_order;<br>page:$v_result_page;<br>";

&display_scorp_search;
&print_scorp_foot;

##############################################
sub display_scorp_search{
####
	my @v_corpus_dir=&load_corpus_dir;
	my @v_search_word_history=&load_search_word_history;
####
	print <<EOF;
<div class="scorp-body">
<center>
<table class="scorp-body" width="650" align="center" border="0">
<tr>
<td class="scorp-body">
<table class="scorp-body" align="center" border="0">
<form action="$scorp_url{"result"}" method="post"> 
<tr>
<td class="scorp-body" align="right">
SEARCH KEY
</td>
<td class="scorp-body" align="left">
<input type="text" name="v_search_word" size="30" value="$v_search_word">
</td>
</tr>
<tr>
<td class="scorp-body" align="right">
SEARCH DIRECTORY
</td>
<td class="scorp-body" align="left">
<select name="v_search_dir" multiple size="5">
EOF
	my $count=0;
	my $corpus_dir_name;
	foreach $corpus_dir_name (@v_corpus_dir){
		$corpus_dir_name_below_top=$corpus_dir_name;
		$corpus_dir_name_below_top=~ s/$v_corpus_top_dir//;
		if($count==0){
			#print "<option ".$select_option{$tmp0[$array_corpus_dir{"select"}]}." value=\"".$_->{"id"}."\" selected>".$_->{"dir_name"}."<\/option>\n";
			print "<option value=\"$corpus_dir_name\" selected>$corpus_dir_name<\/option>\n";
		}else{
			#print "<option ".$select_option{$tmp0[$array_corpus_dir{"select"}]}." value=\"".$_->{"id"}."\">".$_->{"dir_name"}."<\/option>\n";
			print "<option value=\"$corpus_dir_name\">$corpus_dir_name<\/option>\n";
		}
		$count++;
	}
	print <<EOF;
</select>
</td>
</tr>
<tr>
<td class="scorp-body" align="right">
SORT ORDER
</td>
<td class="scorp-body" align="left">
EOF
	if($v_sort_order eq "ascending"){
		print <<EOF;
<input type="radio" name="v_sort_order" value="ascending" checked>ASCENDING
<br>
<input type="radio" name="v_sort_order" value="descending">DESCENDING
EOF
	}elsif($v_sort_order eq "descending"){
		print <<EOF;
<input type="radio" name="v_sort_order" value="ascending">ASCENDING
<br>
<input type="radio" name="v_sort_order" value="descending" checked>DESCENDING
EOF
	}else{
		print <<EOF;
<input type="radio" name="v_sort_order" value="ascending">ASCENDING
<br>
<input type="radio" name="v_sort_order" value="descending">DESCENDING
EOF
	}
	print <<EOF;
</td>
</tr>
<tr>
<td class="scorp-body">
&nbsp;
</td>
<td class="scorp-body" align="right">
<input type="image" src="$scorp_url{'images'}scorp_search.gif" alt="SEARCH" align="left">
<input type="hidden" name="v_sort_key" value="default">
<input type="hidden" name="v_result_page" value="0">
</form>
<form action="$scorp_url{"refresh"}" method="POST">
<input type="image" src="$scorp_url{'images'}scorp_refresh.gif" alt="RELOAD">
<input type="hidden" name="v_search_word" value="">
<input type="hidden" name="v_sort_order" value="">
</form>
</td>
</tr>
</table>
</td>
<td class="scorp-body" valign="top">
<table class="scorp-body" align="center" border="0">
<tr>
<td class="scorp-body" colspan="3">
SEARCH KEY HISTORY
</td>
</tr>
<tr>
<td class="scorp-body">
<form action="$scorp_url{"search"}" method="POST">
<input type="image" src="$scorp_url{'images'}scorp_set.gif" alt="SET">
</td>
<td class="scorp-body" valign="top">
<select name="v_search_word">
EOF
	foreach (@v_search_word_history){
		if($_=~ /[^\.]/){
			print "<option value=\"$_\">$_<\/option>\n";
		}
	}
	print <<EOF;
</select>
</form>
</td>
<td class="scorp-body">
<form action="$scorp_url{"search"}" method="POST">
<input type="image" src="$scorp_url{'images'}scorp_clear.gif" alt="CLEAR">
<input type="hidden" name="clear" value="On">
</form>
</td>
</tr>
</table>
<table>
<table class="scorp-body" align="center" border="0">
<tr>
<td>
<h2 class="scorp-body">
&nbsp;
</h2>
</td>
</tr>
</table>
</td>
</tr>
</table>
</center>
EOF
	print <<EOF;
</div>
EOF
}
