#!/usr/bin/perl
### scorp_show_file.cgi
################################

require "./scorp-lib.pl";
use Encode qw(from_to);
use Encode::Guess qw/euc-jp shiftjis utf8 7bit-jis/;

use utf8;

&ReadParse;

my $v_file_name=$in{'v_file_name'};
my $v_hit_line_id=$in{'v_hit_line_id'};
my $v_hit_word=$in{'v_hit_word'};

##############################################

&print_show_file_head($scorp_title{"result"});
&show_file;
&print_scorp_foot;

##############################################
sub print_show_file_head{
	my ($title) = @_;
	print "Content-type: text/html\n\n";
	print <<EOF;
<html LANG=ja>
<head>
<title>$title</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf8">
<link rel="stylesheet" href="$scorp_url{"style_sheet"}">
</head>
<body>
<div class="scorp-page">
<div class="scorp-head"><img src="$scorp_url{'images'}scorp_head.jpg" alt="headimage" border="0"></div>
EOF
}

sub show_file{
	my $hit_line;
	my $lines;
	my @lines;
	#my @Contents=split(/$LINE_SEPARATOR/,$v_content);
	open(IN,$v_file_name) || &CgiDie("$v_file_name:$!");
	while(<IN>){
		if($.==1){
			$line=$_;
		}else{
			$line=$line.$LINE_SEPARATOR.$_;
		}
	}
	close(IN);

	my $guess=Encode::Guess::guess_encoding($line);
	unless(ref $guess){
		$line=$guess;
	}else{
		from_to($line, 'Guess', 'utf8');
		#utf8::decode($line);
	}

	my @Contents=split(/$LINE_SEPARATOR/,$line);
	my $line_id=0;
	foreach (@Contents){
		$line=$_;
		$line_id++;
		$line=&symbol_code($line);
		if($v_hit_line_id==$line_id){
			$hit_line=$line;
			$hit_line=~ s/$v_hit_word/\<em class=\"scorp-body\"\>$v_hit_word\<\/em\>/g;
			$line="<em class=\"scorp-body\">$line</em>"
		}
		push(@lines,$line);
	}
	
	print <<EOF;
<div class="scorp-body">
<center>
<table class="scorp-body" width="600" border="1">
<caption>
<h3 class="scorp-body">
File Info
</h3>
</caption>
<tr>
<th class="scorp-body-descriptive">
Filename
</th>
<td class="scorp-body">
$v_file_name
</td>
</tr>
<tr>
<th class="scorp-body-descriptive">
Hit Word
</th>
<td class="scorp-body">
<em class="scorp-body">
$v_hit_word
</em>
</td>
</tr>
<tr>
<th class="scorp-body-descriptive">
Hit Line
</th>
<td class="scorp-body">
$v_hit_line_id
</td>
</tr>
</table>
</center>
<p class="scorp-body">
EOF
	my $i=1;
	foreach (@lines){
		#print "$i: $_<br>";
		#print "<p class=\"scorp-body\">";
		print "$_\<br\>";
		#print "</p>";
		$i++;
	}
	print <<EOF;
</p>
</div>
EOF
}
