#!/bin/sh

WebDir=Sites;

if [ ! -d ${HOME}/$WebDir ]; then
	mkdir ${HOME}/$WebDir;
fi
chmod 0777 ${HOME}/$WebDir;

if [ -f ./SCORPVer300.tar.gz ]; then
	tar xzf SCORPVer300.tar.gz -C ${HOME}/$WebDir/;
else
	if [ -d ./SCORPVer300 ]; then
		cp -R ./SCORPVer300/* ${HOME}/$WebDir/;
	fi
fi

if [ ! -d ${HOME}/$WebDir/SCORPVer300/SCORP_LOGS ]; then
	mkdir ${HOME}/$WebDir/SCORPVer300/SCORP_LOGS;
fi
chmod 0777 ${HOME}/$WebDir/SCORPVer300/SCORP_LOGS;

echo "Done."
